import { Class, ClassType, Expression, IInterface, LiteralExpression, TypeDeclaration } from '@azure-tools/codegen-csharp';
export declare const DefaultRunspace: LiteralExpression;
export declare const RunspaceFactory: ClassType;
export declare const PSCmdlet: Class;
export declare const PSCredential: TypeDeclaration;
export declare const PSObject: TypeDeclaration;
export declare const CmdletAttribute: TypeDeclaration;
export declare const ParameterAttribute: TypeDeclaration;
export declare const AllowEmptyCollectionAttribute: TypeDeclaration;
export declare const InvocationInfo: TypeDeclaration;
export declare const PSTypeConverter: Class;
export declare const ValidateNotNull: TypeDeclaration;
export declare const Alias: TypeDeclaration;
export declare const AliasAttribute: TypeDeclaration;
export declare const TypeConverterAttribute: TypeDeclaration;
export declare const ResourceGroupCompleter: TypeDeclaration;
export declare const OutputTypeAttribute: TypeDeclaration;
export declare const ErrorRecord: TypeDeclaration;
export declare const SwitchParameter: TypeDeclaration;
export declare const IArgumentCompleter: IInterface;
export declare const CompletionResult: TypeDeclaration;
export declare const CommandAst: TypeDeclaration;
export declare const CompletionResultType: TypeDeclaration;
export declare const ArgumentCompleterAttribute: TypeDeclaration;
export declare const AsyncCommandRuntime: ClassType;
export declare const AsyncJob: ClassType;
export declare const DescriptionAttribute: TypeDeclaration;
export declare const ExternalDocsAttribute: TypeDeclaration;
export declare const DoNotExportAttribute: TypeDeclaration;
export declare const InternalExportAttribute: TypeDeclaration;
export declare const GeneratedAttribute: TypeDeclaration;
export declare const ProfileAttribute: TypeDeclaration;
export declare const CategoryAttribute: TypeDeclaration;
export declare const ExportAsAttribute: TypeDeclaration;
export declare const ParameterCategory: TypeDeclaration;
export declare const PSArgumentCompleterAttribute: TypeDeclaration;
export declare const HttpPathAttribute: TypeDeclaration;
export declare const NotSuggestDefaultParameterSetAttribute: TypeDeclaration;
export declare function ErrorCategory(category: string): Expression;
export declare function verbEnum(category: string, verb: string): Expression;
export declare const Events: ClassType & {
    BodyContentSet: LiteralExpression;
    BeforeCall: LiteralExpression;
    BeforeResponseDispatch: LiteralExpression;
    Log: LiteralExpression;
    Validation: LiteralExpression;
    VaidationWarning: LiteralExpression;
    AfterValidation: LiteralExpression;
    RequestCreated: LiteralExpression;
    ResponseCreated: LiteralExpression;
    HeaderParametersAdded: LiteralExpression;
    URLCreated: LiteralExpression;
    Finally: LiteralExpression;
    Polling: LiteralExpression;
    DelayBeforePolling: LiteralExpression;
    Progress: LiteralExpression;
} & {
    CmdletProcessRecordStart: LiteralExpression;
    CmdletProcessRecordAsyncStart: LiteralExpression;
    CmdletException: LiteralExpression;
    CmdletGetPipeline: LiteralExpression;
    CmdletBeforeAPICall: LiteralExpression;
    CmdletAfterAPICall: LiteralExpression;
    CmdletBeginProcessing: LiteralExpression;
    CmdletEndProcessing: LiteralExpression;
    CmdletProcessRecordEnd: LiteralExpression;
    CmdletProcessRecordAsyncEnd: LiteralExpression;
    FollowingNextLink: LiteralExpression;
    Verbose: LiteralExpression;
    Debug: LiteralExpression;
    Information: LiteralExpression;
    Error: LiteralExpression;
    Warning: LiteralExpression;
};
