import { ClassType } from '@azure-tools/codegen-csharp';
import { Expression, ExpressionOrLiteral, LiteralExpression } from '@azure-tools/codegen-csharp';
import { Interface } from '@azure-tools/codegen-csharp';
import { Namespace } from '@azure-tools/codegen-csharp';
export declare const ClientRuntime: Namespace & {
    AttachDebugger: ClassType;
    Method: ClassType & {
        Get: LiteralExpression;
        Put: LiteralExpression;
        Post: LiteralExpression;
        Delete: LiteralExpression;
        Options: LiteralExpression;
        Head: LiteralExpression;
        Trace: LiteralExpression;
        Patch: LiteralExpression;
    };
    InfoAttribute: ClassType;
    CompleterInfoAttribute: ClassType;
    DefaultInfoAttribute: ClassType;
    GeneraricBreakingChangeAttribute: ClassType;
    CmdletBreakingChangeAttribute: ClassType;
    ParameterSetBreakingChangeAttribute: ClassType;
    OutputBreakingChangeAttribute: ClassType;
    ParameterBreakingChangeAttribute: ClassType;
    PreviewMessageAttribute: ClassType;
    EventDataConverter: ClassType;
    ISendAsync: Interface;
    Extensions: ClassType;
    PowerShell: ClassType;
    Cmdlets: ClassType;
    IJsonSerializable: Interface;
    JsonSerializable: Interface;
    IXmlSerializable: Interface;
    IEventListener: Interface;
    IContext: Interface;
    IValidates: Interface;
    IHeaderSerializable: Interface;
    SerializationMode: ClassType & {
        None: LiteralExpression;
        IncludeAll: LiteralExpression;
        IncludeHeaders: LiteralExpression;
        IncludeCreate: LiteralExpression;
        IncludeUpdate: LiteralExpression;
        IncludeRead: LiteralExpression;
        IncludeCreateOrUpdate: LiteralExpression;
    };
    HttpPipeline: ClassType;
    HttpClientFactory: ClassType;
    SendAsyncStep: ClassType;
    SendAsyncSteps: ClassType;
    EventData: ClassType;
    EventListener: ClassType;
    Events: ClassType & {
        BodyContentSet: LiteralExpression;
        BeforeCall: LiteralExpression;
        BeforeResponseDispatch: LiteralExpression;
        Log: LiteralExpression;
        Validation: LiteralExpression;
        VaidationWarning: LiteralExpression;
        AfterValidation: LiteralExpression;
        RequestCreated: LiteralExpression;
        ResponseCreated: LiteralExpression;
        HeaderParametersAdded: LiteralExpression;
        URLCreated: LiteralExpression;
        Finally: LiteralExpression;
        Polling: LiteralExpression;
        DelayBeforePolling: LiteralExpression;
        Progress: LiteralExpression;
    };
    KeyValuePairs: ClassType;
    JsonNode: ClassType & {
        Parse: (expression: ExpressionOrLiteral) => Expression;
    };
    JsonObject: ClassType & {
        Parse: (expression: Expression) => Expression;
    };
    JsonString: ClassType;
    JsonBoolean: ClassType;
    JsonNumber: ClassType;
    JsonArray: ClassType & {
        Parse: (expression: ExpressionOrLiteral) => Expression;
    };
    JsonType: ClassType & {
        Null: LiteralExpression;
        Object: LiteralExpression;
        Array: LiteralExpression;
        Binary: LiteralExpression;
        Boolean: LiteralExpression;
        Date: LiteralExpression;
        Number: LiteralExpression;
        String: LiteralExpression;
    };
    XNodeArray: ClassType;
};
