import { Expression, ExpressionOrLiteral } from '@azure-tools/codegen-csharp';
import { KnownMediaType } from '@azure-tools/codemodel-v3';
import { OneOrMoreStatements } from '@azure-tools/codegen-csharp';
import { Struct } from '@azure-tools/codegen-csharp';
import { Variable } from '@azure-tools/codegen-csharp';
import { EnumImplementation } from '../schema/enum';
import { EnhancedTypeDeclaration } from '../schema/extended-type-declaration';
import { State } from '../generator';
import { DeepPartial } from '@azure-tools/codegen';
import { Schema as NewSchema } from '@autorest/codemodel';
export declare class EnumClass extends Struct implements EnhancedTypeDeclaration {
    implementation: EnumImplementation;
    get schema(): NewSchema;
    get convertObjectMethod(): string;
    get defaultOfType(): Expression;
    deserializeFromContainerMember(mediaType: KnownMediaType, container: ExpressionOrLiteral, serializedName: string, defaultValue: Expression): Expression;
    deserializeFromNode(mediaType: KnownMediaType, node: ExpressionOrLiteral, defaultValue: Expression): Expression;
    /** emits an expression to deserialize content from a string */
    deserializeFromString(mediaType: KnownMediaType, content: ExpressionOrLiteral, defaultValue: Expression): Expression | undefined;
    /** emits an expression to deserialize content from a content/response */
    deserializeFromResponse(mediaType: KnownMediaType, content: ExpressionOrLiteral, defaultValue: Expression): Expression | undefined;
    serializeToNode(mediaType: KnownMediaType, value: ExpressionOrLiteral, serializedName: string, mode: Expression): Expression;
    /** emits an expression serialize this to a HttpContent */
    serializeToContent(mediaType: KnownMediaType, value: ExpressionOrLiteral, mode: Expression): Expression;
    serializeToContainerMember(mediaType: KnownMediaType, value: ExpressionOrLiteral, container: Variable, serializedName: string, mode: Expression): OneOrMoreStatements;
    get isXmlAttribute(): boolean;
    get isNullable(): boolean;
    get isRequired(): boolean;
    constructor(schemaWithFeatures: EnumImplementation, state: State, objectInitializer?: DeepPartial<EnumClass>);
    validateValue(eventListener: Variable, property: Variable): OneOrMoreStatements;
    validatePresence(eventListener: Variable, property: Variable): OneOrMoreStatements;
}
