import { AutorestExtensionHost as Host } from '@autorest/extension-base';
import { Dictionary } from '@azure-tools/linq';
import { Project as codeDomProject } from '@azure-tools/codegen-csharp';
import { State } from './generator';
import { ModelsNamespace } from './model/namespace';
import { ServiceNamespace } from './operation/namespace';
import { SupportNamespace } from './enums/namespace';
import { DeepPartial } from '@azure-tools/codegen';
import { PropertyFormat } from '../utils/schema';
export declare class Project extends codeDomProject {
    protected service: Host;
    jsonSerialization: boolean;
    xmlSerialization: boolean;
    defaultPipeline: boolean;
    emitSignals: boolean;
    enableApiRetry: boolean;
    exportPropertiesForDict: boolean;
    projectNamespace: string;
    overrides: Dictionary<string>;
    state: State;
    apifolder: string;
    runtimefolder: string;
    azure: boolean;
    license: string;
    identityCorrection: boolean;
    resourceGroupAppend: boolean;
    supportJsonInput: boolean;
    formats: Dictionary<PropertyFormat>;
    constructor(service: Host, objectInitializer?: DeepPartial<Project>);
    init(): Promise<this>;
    serviceNamespace: ServiceNamespace;
    modelsNamespace: ModelsNamespace;
    supportNamespace: SupportNamespace;
}
