"use strict";
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.Boolean = void 0;
const clientruntime_1 = require("../clientruntime");
const primitive_1 = require("./primitive");
class Boolean extends primitive_1.NewPrimitive {
    constructor(schema, isRequired) {
        super(schema);
        this.isRequired = isRequired;
        this.isXmlAttribute = false;
        this.jsonType = clientruntime_1.ClientRuntime.JsonBoolean;
    }
    get declaration() {
        return `bool${this.isRequired ? '' : '?'}`;
    }
    validateValue(eventListener, property) {
        return '';
    }
}
exports.Boolean = Boolean;
//# sourceMappingURL=boolean.js.map