import { KnownMediaType } from '@azure-tools/codemodel-v3';
import { Expression, ExpressionOrLiteral } from '@azure-tools/codegen-csharp';
import { OneOrMoreStatements } from '@azure-tools/codegen-csharp';
import { Variable } from '@azure-tools/codegen-csharp';
import { ObjectSchema } from '@autorest/codemodel';
import { EnhancedTypeDeclaration } from './extended-type-declaration';
export declare class ObjectImplementation implements EnhancedTypeDeclaration {
    schema: ObjectSchema;
    isXmlAttribute: boolean;
    get defaultOfType(): Expression;
    get isNullable(): boolean;
    get convertObjectMethod(): string;
    deserializeFromContainerMember(mediaType: KnownMediaType, container: ExpressionOrLiteral, serializedName: string, defaultValue: Expression): Expression;
    /** emits an expression to deserialze a container as the value itself. */
    deserializeFromNode(mediaType: KnownMediaType, node: ExpressionOrLiteral, defaultValue: Expression): Expression;
    /** emits an expression serialize this to a HttpContent */
    serializeToNode(mediaType: KnownMediaType, value: ExpressionOrLiteral, serializedName: string, mode: Expression): Expression;
    /** emits an expression serialize this to the value required by the container */
    serializeToContent(mediaType: KnownMediaType, value: ExpressionOrLiteral, mode: Expression): Expression;
    /** emits an expression to deserialize content from a string */
    deserializeFromString(mediaType: KnownMediaType, content: ExpressionOrLiteral, defaultValue: Expression): Expression | undefined;
    /** emits an expression to deserialize content from a content/response */
    deserializeFromResponse(mediaType: KnownMediaType, content: ExpressionOrLiteral, defaultValue: Expression): Expression | undefined;
    /** emits the code required to serialize this into a container */
    serializeToContainerMember(mediaType: KnownMediaType, value: ExpressionOrLiteral, container: Variable, serializedName: string, mode: Expression): OneOrMoreStatements;
    isRequired: boolean;
    constructor(schema: ObjectSchema);
    validatePresence(eventListener: Variable, property: Variable): OneOrMoreStatements;
    validateValue(eventListener: Variable, property: Variable): OneOrMoreStatements;
    get declaration(): string;
    get classDeclaration(): string;
}
