import { KnownMediaType } from '@azure-tools/codemodel-v3';
import { Expression, ExpressionOrLiteral } from '@azure-tools/codegen-csharp';
import { OneOrMoreStatements } from '@azure-tools/codegen-csharp';
import { Variable } from '@azure-tools/codegen-csharp';
import { Schema as NewSchema } from '@autorest/codemodel';
import { EnhancedTypeDeclaration } from './extended-type-declaration';
/** A ETD for the c# string type. */
export declare class String implements EnhancedTypeDeclaration {
    schema: NewSchema;
    isRequired: boolean;
    isXmlAttribute: boolean;
    get defaultOfType(): Expression;
    get convertObjectMethod(): string;
    get isNullable(): boolean;
    get encode(): string;
    deserializeFromContainerMember(mediaType: KnownMediaType, container: ExpressionOrLiteral, serializedName: string, defaultValue: Expression): Expression;
    deserializeFromNode(mediaType: KnownMediaType, node: ExpressionOrLiteral, defaultValue: Expression): Expression;
    /** emits an expression serialize this to a HttpContent */
    serializeToContent(mediaType: KnownMediaType, value: ExpressionOrLiteral, mode: Expression): Expression;
    serializeToNode(mediaType: KnownMediaType, value: ExpressionOrLiteral, serializedName: string, mode: Expression): Expression;
    /** emits an expression to deserialize content from a string */
    deserializeFromString(mediaType: KnownMediaType, content: ExpressionOrLiteral, defaultValue: Expression): Expression | undefined;
    /** emits an expression to deserialize content from a content/response */
    deserializeFromResponse(mediaType: KnownMediaType, content: ExpressionOrLiteral, defaultValue: Expression): Expression | undefined;
    serializeToContainerMember(mediaType: KnownMediaType, value: ExpressionOrLiteral, container: Variable, serializedName: string, mode: Expression): OneOrMoreStatements;
    constructor(schema: NewSchema, isRequired: boolean);
    get declaration(): string;
    validateValue(eventListener: Variable, property: Variable): string;
    validatePresence(eventListener: Variable, property: Variable): string;
    private validateMinLength;
    private validateMaxLength;
    private validateRegex;
    private validateEnum;
}
