import { CodeModel } from '@autorest/codemodel';
import { AutorestExtensionHost as Host, JsonPointerSegments as JsonPath } from '@autorest/extension-base';
import { Project } from './project';
import { DeepPartial } from '@azure-tools/codegen';
import { ModelState } from '../utils/model-state';
export interface GeneratorSettings {
    azure: boolean;
    cmdletFolder: string;
    customFolder: string;
    runtimeFolder: string;
    moduleName: string;
    csproj: string;
    psd1: string;
    psm1: string;
    apiFolder: string;
}
export declare class State extends ModelState<CodeModel> {
    project: Project;
    constructor(service: Host, objectInitializer?: DeepPartial<State>);
    init(project?: Project): Promise<this>;
    path(...childPath: JsonPath): this;
}
