import { VirtualProperty, VirtualProperties } from '../utils/schema';
import { ObjectSchema, Schema, Parameter, Operation } from '@autorest/codemodel';
export declare class Helper {
    useDateTimeOffset: boolean;
    constructor(useDateTimeOffset?: boolean);
    HasConstrains(schema: Schema): boolean;
    HasConstantProperty(schema: Schema): boolean;
    GetCsharpType(schema: Schema): string;
    private isArraySchema;
    private isDictionarySchema;
    private ShouldValidate;
    private appendConstraintValidations;
    private isKindOfString;
    PathParameterString(parameter: Parameter, clientPrefix: string): string;
    ValidateType(schema: Schema, scope: any, valueReference: string, isNullable: boolean, indentation?: number): string;
    ShouldValidateChain(schema: Schema): boolean;
    GetDeserializationSettings(schema: Schema, ref: string): string;
    GetSerializationSettings(schema: Schema, ref: string): string;
    IsNullCheckRequiredForVirtualProperty(virtualProperty: VirtualProperty): boolean;
    CamelCase(str: string): string;
    PascalCase(str: string): string;
    GetAllPublicVirtualProperties(virtualProperties?: VirtualProperties): Array<VirtualProperty>;
    GetAllPublicVirtualPropertiesWithoutInherited(virtualProperties?: VirtualProperties): Array<VirtualProperty>;
    NeedsTransformationConverter(object: ObjectSchema): boolean;
    IsValueType(type: string): boolean;
    HandleConstParameters(operation: Operation): string;
    IsConstantEnumParameter(parameter: Parameter): boolean;
    IsConstantParameter(parameter: Parameter): boolean;
    IsConstantEnumProperty(property: VirtualProperty): boolean;
    IsConstantProperty(property: VirtualProperty): boolean;
    GetUniqueName(name: string, usedNames: Array<string>): string;
    GetValidCsharpName(name: string): string;
    IsEnum(schema: Schema): boolean;
    ConvertToValidMethodGroupKey(key: string): string;
    private isCloudErrorName;
    IsCloudErrorException(operation: Operation): boolean;
    PopulateGroupParameters(parameter: Parameter): string;
    wrapComments(indentation: string, prefix: string, comments: string): string;
    private lineBreak;
}
