"use strict";
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("@testdeck/mocha");
const assert = __importStar(require("assert"));
const ps_namer_v2_1 = require("../plugins/ps-namer-v2");
let TestNounCleaning = (() => {
    let _classDecorators = [mocha_1.suite];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _instanceExtraInitializers = [];
    let _member_decorators;
    var TestNounCleaning = class {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
            _member_decorators = [mocha_1.test];
            __esDecorate(this, null, _member_decorators, { kind: "method", name: 'deduplicate information from the cmdlet noun', static: false, private: false, access: { has: obj => 'deduplicate information from the cmdlet noun' in obj, get: obj => obj['deduplicate information from the cmdlet noun'] }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            TestNounCleaning = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
            __runInitializers(_classThis, _classExtraInitializers);
        }
        async 'deduplicate information from the cmdlet noun'() {
            const subjectPrefix1 = 'AppConfiguration';
            const subject1 = 'ConfigurationStore';
            const expectedNounParts1 = { subject: 'ConfigurationStore', subjectPrefix: 'App' };
            const actual1 = (0, ps_namer_v2_1.getDeduplicatedNoun)(subjectPrefix1, subject1);
            assert.deepStrictEqual(actual1, expectedNounParts1);
            const subjectPrefix2 = 'AppConfiguration';
            const subject2 = 'ConfigurationStoreKey';
            const expectedNounParts2 = { subject: 'ConfigurationStoreKey', subjectPrefix: 'App' };
            const actual2 = (0, ps_namer_v2_1.getDeduplicatedNoun)(subjectPrefix2, subject2);
            assert.deepStrictEqual(actual2, expectedNounParts2);
            const subjectPrefix3 = 'ContainerService';
            const subject3 = 'ContainerService';
            const expectedNounParts3 = { subject: 'ContainerService', subjectPrefix: '' };
            const actual3 = (0, ps_namer_v2_1.getDeduplicatedNoun)(subjectPrefix3, subject3);
            assert.deepStrictEqual(actual3, expectedNounParts3);
            const subjectPrefix4 = 'ContainerService';
            const subject4 = 'ContainerServiceSomething';
            const expectedNounParts4 = { subject: 'ContainerServiceSomething', subjectPrefix: '' };
            const actual4 = (0, ps_namer_v2_1.getDeduplicatedNoun)(subjectPrefix4, subject4);
            assert.deepStrictEqual(actual4, expectedNounParts4);
            const subjectPrefix5 = 'WebFoo';
            const subject5 = 'BarFooBarBlah';
            const expectedNounParts5 = { subject: 'FooBarBlah', subjectPrefix: 'Web' };
            const actual5 = (0, ps_namer_v2_1.getDeduplicatedNoun)(subjectPrefix5, subject5);
            assert.deepStrictEqual(actual5, expectedNounParts5);
            const subjectPrefix6 = 'Hi';
            const subject6 = 'HelloHiHolaHallo';
            const expectedNounParts6 = { subject: 'HelloHiHolaHallo', subjectPrefix: 'Hi' };
            const actual6 = (0, ps_namer_v2_1.getDeduplicatedNoun)(subjectPrefix6, subject6);
            assert.deepStrictEqual(actual6, expectedNounParts6);
        }
        constructor() {
            __runInitializers(this, _instanceExtraInitializers);
        }
    };
    return TestNounCleaning = _classThis;
})();
//# sourceMappingURL=noun-cleaning.js.map