import { Extensions } from './extensions';
import { Dictionary } from '@azure-tools/linq';
import { DeepPartial } from '@azure-tools/codegen';
export declare class Contact extends Extensions implements Contact {
    extensions: Dictionary<any>;
    constructor(initializer?: DeepPartial<Contact>);
}
export declare class Info extends Extensions implements Info {
    title: string;
    version: string;
    extensions: Dictionary<any>;
    constructor(title: string, version: string, initializer?: DeepPartial<Info>);
}
export declare class License extends Extensions implements License {
    name: string;
    extensions: Dictionary<any>;
    constructor(name: string, initializer?: DeepPartial<License>);
}
export interface Contact extends Extensions {
    name?: string;
    url?: string;
    email?: string;
}
export interface Info extends Extensions {
    title: string;
    description?: string;
    termsOfService?: string;
    contact?: Contact;
    license?: License;
    version: string;
}
export interface License extends Extensions {
    name: string;
    url?: string;
}
