import { ImplementationDetails, IOperation, IParameter, LanguageDetails } from './components';
import { Extensions } from './extensions';
import { Schema } from '@autorest/codemodel';
import { Dictionary } from '@azure-tools/linq';
import { DeepPartial } from '@azure-tools/codegen';
export interface ProgrammaticOperation extends IOperation<IParameter> {
    responses: Dictionary<Dictionary<Schema>>;
    pure: boolean;
}
export interface IntrinsicOperation extends ProgrammaticOperation {
}
export declare class IntrinsicOperation extends Extensions implements IntrinsicOperation {
    details: LanguageDetails<ProgramaticOperationDetails>;
    responses: Dictionary<Dictionary<Schema>>;
    operationType: 'IntrinsicOperation';
    constructor(name: string, deprecated: boolean, pure: boolean, initializer?: DeepPartial<IntrinsicOperation>);
}
export interface ProgramaticOperationDetails extends ImplementationDetails {
}
